﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using irwinAPI.Models.DB;

namespace irwinAPI.Migrations
{
    [DbContext(typeof(IrwinContext))]
    [Migration("20200824205932_AddCascadeDelete")]
    partial class AddCascadeDelete
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.6")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("irwinAPI.Models.DB.Areas", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("CotizacionId")
                        .HasColumnType("int");

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.HasIndex("CotizacionId")
                        .HasName("IX_CotizacionId");

                    b.ToTable("Areas");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Clientes", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Direccion")
                        .HasColumnType("nvarchar(200)")
                        .HasMaxLength(200);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<string>("Telefono")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Clientes");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.CostosHumanos", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Codigo")
                        .IsRequired()
                        .HasColumnType("nvarchar(50)")
                        .HasMaxLength(50);

                    b.Property<double>("Costo")
                        .HasColumnType("float");

                    b.Property<string>("Detalle")
                        .IsRequired()
                        .HasColumnType("nvarchar(100)")
                        .HasMaxLength(100);

                    b.HasKey("Id");

                    b.ToTable("CostosHumanos");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.CostosHumanosDetalle", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AreaId")
                        .HasColumnType("int");

                    b.Property<int>("Cantidad")
                        .HasColumnType("int");

                    b.Property<int>("CostoHumanoId")
                        .HasColumnType("int");

                    b.Property<int?>("CotizacionId")
                        .HasColumnType("int");

                    b.Property<bool>("EsProyecto")
                        .HasColumnType("bit");

                    b.HasKey("Id");

                    b.HasIndex("AreaId")
                        .HasName("IX_AreaId");

                    b.HasIndex("CostoHumanoId")
                        .HasName("IX_CostoHumanoId");

                    b.HasIndex("CotizacionId")
                        .HasName("IX_CotizacionId");

                    b.ToTable("CostosHumanosDetalle");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Cotizaciones", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("ClienteId")
                        .HasColumnType("int");

                    b.Property<string>("Descripcion")
                        .HasColumnType("nvarchar(2000)")
                        .HasMaxLength(2000);

                    b.Property<DateTime?>("Fecha")
                        .HasColumnType("date");

                    b.HasKey("Id");

                    b.HasIndex("ClienteId")
                        .HasName("IX_ClienteId");

                    b.ToTable("Cotizaciones");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Equipos", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Capacidad")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<string>("Codigo")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<int?>("GasId")
                        .HasColumnType("int");

                    b.Property<int?>("MarcaId")
                        .HasColumnType("int");

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<decimal?>("Precio")
                        .HasColumnType("decimal(18, 2)");

                    b.Property<int?>("TecnologiaId")
                        .HasColumnType("int");

                    b.Property<int?>("TipoId")
                        .HasColumnType("int");

                    b.Property<int?>("VoltajeId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("GasId")
                        .HasName("IX_GasId");

                    b.HasIndex("MarcaId")
                        .HasName("IX_MarcaId");

                    b.HasIndex("TecnologiaId")
                        .HasName("IX_TecnologiaId");

                    b.HasIndex("TipoId")
                        .HasName("IX_TipoId");

                    b.HasIndex("VoltajeId");

                    b.ToTable("Equipos");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.EquiposAreas", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AreaId")
                        .HasColumnType("int");

                    b.Property<int?>("EquipoId")
                        .HasColumnType("int");

                    b.Property<double?>("PorcentajeGanancia")
                        .HasColumnType("float");

                    b.Property<decimal?>("PrecioEquipo")
                        .HasColumnType("decimal(18, 2)");

                    b.Property<decimal?>("PrecioMaterialesEquipo")
                        .HasColumnType("decimal(18, 2)");

                    b.Property<decimal>("PrecioTotalPersonalizado")
                        .HasColumnType("decimal(18, 2)");

                    b.HasKey("Id");

                    b.HasIndex("AreaId")
                        .HasName("IX_AreaId");

                    b.HasIndex("EquipoId")
                        .HasName("IX_EquipoId");

                    b.ToTable("EquiposAreas");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Gases", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Gases");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Marcas", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Marcas");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.MaterialEquipoAreas", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("Cantidad")
                        .HasColumnType("int");

                    b.Property<int?>("EquiposAreaId")
                        .HasColumnType("int");

                    b.Property<int?>("MaterialId")
                        .HasColumnType("int");

                    b.Property<double?>("PorcentajeGanancia")
                        .HasColumnType("float");

                    b.Property<decimal?>("Precio")
                        .HasColumnType("decimal(18, 2)");

                    b.HasKey("Id");

                    b.HasIndex("EquiposAreaId")
                        .HasName("IX_EquiposAreaId");

                    b.HasIndex("MaterialId")
                        .HasName("IX_MaterialId");

                    b.ToTable("MaterialEquipoAreas");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Materiales", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Codigo")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<int?>("MarcaId")
                        .HasColumnType("int");

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<decimal?>("Precio")
                        .HasColumnType("decimal(18, 2)");

                    b.Property<int?>("TipoId")
                        .HasColumnType("int");

                    b.Property<int?>("UnidadMedidaId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("MarcaId")
                        .HasName("IX_MarcaId");

                    b.HasIndex("TipoId")
                        .HasName("IX_TipoId");

                    b.HasIndex("UnidadMedidaId")
                        .HasName("IX_UnidadMedidaId");

                    b.ToTable("Materiales");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Tecnologias", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Tecnologias");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Tipos", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Tipos");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.UnidadMedidas", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Abreviatura")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("UnidadMedidas");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Usuarios", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Contraseña")
                        .IsRequired()
                        .HasColumnType("varchar(200)")
                        .HasMaxLength(200)
                        .IsUnicode(false);

                    b.Property<string>("Usuario")
                        .IsRequired()
                        .HasColumnType("varchar(20)")
                        .HasMaxLength(20)
                        .IsUnicode(false);

                    b.HasKey("Id");

                    b.ToTable("Usuarios");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Voltajes", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Nombre")
                        .HasColumnType("nvarchar(45)")
                        .HasMaxLength(45);

                    b.HasKey("Id");

                    b.ToTable("Voltajes");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Areas", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Cotizaciones", "Cotizacion")
                        .WithMany("Areas")
                        .HasForeignKey("CotizacionId")
                        .HasConstraintName("FK_dbo.Areas_dbo.Cotizaciones_CotizacionId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.CostosHumanosDetalle", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Areas", "Area")
                        .WithMany("CostosHumanosDetalle")
                        .HasForeignKey("AreaId")
                        .HasConstraintName("FK_dbo.CostosHumanosDetalle_dbo.Areas_AreaId");

                    b.HasOne("irwinAPI.Models.DB.CostosHumanos", "CostoHumano")
                        .WithMany("CostosHumanosDetalle")
                        .HasForeignKey("CostoHumanoId")
                        .HasConstraintName("FK_dbo.CostosHumanosDetalle_dbo.CostosHumanos_CostoHumanoId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("irwinAPI.Models.DB.Cotizaciones", "Cotizacion")
                        .WithMany("CostosHumanosDetalle")
                        .HasForeignKey("CotizacionId")
                        .HasConstraintName("FK_dbo.CostosHumanosDetalle_dbo.Cotizaciones_CotizacionId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Cotizaciones", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Clientes", "Cliente")
                        .WithMany("Cotizaciones")
                        .HasForeignKey("ClienteId")
                        .HasConstraintName("FK_dbo.Cotizaciones_dbo.Clientes_ClienteId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Equipos", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Gases", "Gas")
                        .WithMany("Equipos")
                        .HasForeignKey("GasId")
                        .HasConstraintName("FK_dbo.Equipos_dbo.Gases_GasId");

                    b.HasOne("irwinAPI.Models.DB.Marcas", "Marca")
                        .WithMany("Equipos")
                        .HasForeignKey("MarcaId")
                        .HasConstraintName("FK_dbo.Equipos_dbo.Marcas_MarcaId");

                    b.HasOne("irwinAPI.Models.DB.Tecnologias", "Tecnologia")
                        .WithMany("Equipos")
                        .HasForeignKey("TecnologiaId")
                        .HasConstraintName("FK_dbo.Equipos_dbo.Tecnologias_TecnologiaId");

                    b.HasOne("irwinAPI.Models.DB.Tipos", "Tipo")
                        .WithMany("Equipos")
                        .HasForeignKey("TipoId")
                        .HasConstraintName("FK_dbo.Equipos_dbo.Tipos_TipoId");

                    b.HasOne("irwinAPI.Models.DB.Voltajes", "Voltaje")
                        .WithMany("Equipos")
                        .HasForeignKey("VoltajeId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.EquiposAreas", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Areas", "Area")
                        .WithMany("EquiposAreas")
                        .HasForeignKey("AreaId")
                        .HasConstraintName("FK_dbo.EquiposAreas_dbo.Areas_AreaId");

                    b.HasOne("irwinAPI.Models.DB.Equipos", "Equipo")
                        .WithMany("EquiposAreas")
                        .HasForeignKey("EquipoId")
                        .HasConstraintName("FK_dbo.EquiposAreas_dbo.Equipos_EquipoId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.MaterialEquipoAreas", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.EquiposAreas", "EquiposArea")
                        .WithMany("MaterialEquipoAreas")
                        .HasForeignKey("EquiposAreaId")
                        .HasConstraintName("FK_dbo.MaterialEquipoAreas_dbo.EquiposAreas_EquiposAreaId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("irwinAPI.Models.DB.Materiales", "Material")
                        .WithMany("MaterialEquipoAreas")
                        .HasForeignKey("MaterialId")
                        .HasConstraintName("FK_dbo.MaterialEquipoAreas_dbo.Materiales_MaterialId");
                });

            modelBuilder.Entity("irwinAPI.Models.DB.Materiales", b =>
                {
                    b.HasOne("irwinAPI.Models.DB.Marcas", "Marca")
                        .WithMany("Materiales")
                        .HasForeignKey("MarcaId")
                        .HasConstraintName("FK_dbo.Materiales_dbo.Marcas_MarcaId");

                    b.HasOne("irwinAPI.Models.DB.Tipos", "Tipo")
                        .WithMany("Materiales")
                        .HasForeignKey("TipoId")
                        .HasConstraintName("FK_dbo.Materiales_dbo.Tipos_TipoId");

                    b.HasOne("irwinAPI.Models.DB.UnidadMedidas", "UnidadMedida")
                        .WithMany("Materiales")
                        .HasForeignKey("UnidadMedidaId")
                        .HasConstraintName("FK_dbo.Materiales_dbo.UnidadMedidas_UnidadMedidaId");
                });
#pragma warning restore 612, 618
        }
    }
}
